// Un cylindre

/* VARIABLES GÉNÉRALES
** valeurs à déterminer par l'utilisateur
*/
float a = -2, b = 2; // intervalle u
float c = 0, d = 2*PI; // intervalle v
int n = 20, m = 40; // n = nombre de divisionS de [a, b], m idem pour [c, d]

// Les couleurs
float couleur1R = 255;
float couleur1G = 0;
float couleur1B = 0; 
float couleur2R = 0;
float couleur2G = 255;
float couleur2B = 0;

/* LES FONCTIONS COORDONNÉES : 
** doivent toujours être présentes et
** leur contenu détermine la figure
** qui sera tracée. 
*/
float f(float u, float v){
  return r*cos(v);
}

float g(float u, float v){
  return r*sin(v);
}

float h(float u, float v){
  return u;
}

// Variables dépendantes des choix faits plus haut
// Ne pas modifier !
float du = (b-a)/n; // accroissement sur u pour passer d'un sommet à l'autre
float dv = (d-c)/m; // accroissement sur v pour passer d'un sommet à l'autre

// Variables spécifiques à la figure tracée
// Ici un cylindre

float r = 2; // rayon du cylindre


/* definirFigure contient le calcul des sommets et des faces
** qui ici dépendent des choix faits plus haut et aussi des 
** fonctions coordonnées.
** Donc ne pas modifier, sauf peut être pour les couleurs !!!
**/
void definirFigure(){
  pixelsParUnite(50);
  // Calcul des sommets
  for(int i = 0; i <= n; i++){
    for(int j = 0; j <= m; j++){
      definirSommet(i*(m+1)+j+1, f(a+i*du, c+j*dv), g(a+i*du, c+j*dv), h(a+i*du, c+j*dv));
      //println(i*(m+1)+j+1);
    }//j
  }//i
  // calcul des faces
  int ecart = n*m;
  for(int i=0; i < n; i++){
    for(int j = 0; j< m; j++){
      definirFace(i*(m+1)+j+1-i, i*(m+1)+j+1, i*(m+1)+j+2, (i+1)*(m+1)+j+1);
      definirFace(ecart+i*(m+1)+j+1-i, i*(m+1)+j+2, (i+1)*(m+1)+j+2, (i+1)*(m+1)+j+1);
      if ((i+j)%2 == 0){
        couleurFace(i*(m+1)+j+1-i, couleur1R, couleur1G, couleur1B);
        couleurFace(i*(m+1)+j+1-i+ecart, couleur1R, couleur1G, couleur1B);
      }else{
        couleurFace(i*(m+1)+j+1-i, couleur2R, couleur2G, couleur2B);
        couleurFace(i*(m+1)+j+1-i+ecart, couleur2R, couleur2G, couleur2B);
      }
    }//j
  }//i
}

void initialiserFigure(){
  fixeRotationX(30);
  fixeRotationY(25);
}

void redefinirCertainsSommets(){
  
}


