// Un cylindre

float a = 0, b=2*PI; // intervalle u
float c = 0, d = PI; // intervalle v
int n = 40, m = 40; // n = nombre de division de [a, b], m idem pour [c, d]

// Les couleurs
float couleur1R = 255;
float couleur1G = 0;
float couleur1B = 0; 
float couleur2R = 0;
float couleur2G = 255;
float couleur2B = 0;

float du = (b-a)/n; // accroissement sur u pour passer d'un sommet à l'autre
float dv = (d-c)/m; // accroissement sur v pour passer d'un sommet à l'autre


float r = 3; // rayon du cylindre
int pas = 0;

// les fonctions coordonnées
// x-coordonnée
float f(float u, float v){
  return r*sin(v)*cos(u);
}
// y-coordonnée
float g(float u, float v){
  return r*sin(v)*sin(u);
}
// z-coordonnée
float h(float u, float v){
  return r*cos(v);
}
//*************************************
void definirFigure(){
  pixelsParUnite(50);
  
  // NE PAS MODIFIER
  // Calcul des sommets
  for(int i = 0; i <= n; i++){
    for(int j = 0; j <= m; j++){
      definirSommet(i*(m+1)+j+1, f(a+i*du, c+j*dv), g(a+i*du, c+j*dv), h(a+i*du, c+j*dv));
      //println(i*(m+1)+j+1);
    }//j
  }//i
  // calcul des faces
  int ecart = n*m;
  for(int i=0; i < n; i++){
    for(int j = 0; j< m; j++){
      definirFace(i*(m+1)+j+1-i, i*(m+1)+j+1, i*(m+1)+j+2, (i+1)*(m+1)+j+1);
      definirFace(ecart+i*(m+1)+j+1-i, i*(m+1)+j+2, (i+1)*(m+1)+j+2, (i+1)*(m+1)+j+1);
      if ((i+j)%2 == 0){
        couleurFace(i*(m+1)+j+1-i, couleur1R, couleur1G, couleur1B);
        couleurFace(i*(m+1)+j+1-i+ecart, couleur1R, couleur1G, couleur1B);
      }else{
        couleurFace(i*(m+1)+j+1-i, couleur2R, couleur2G, couleur2B);
        couleurFace(i*(m+1)+j+1-i+ecart, couleur2R, couleur2G, couleur2B);
      }
    }//j
  }//i
  // FIN DE "NE PAS MODIFIER"
  
  creerGlissiereG1("théta max", 0, 1, 1);
  creerGlissiereG2("phi max", 0, 1, 1);
}

void initialiserFigure(){
  fixeRotationX(30);
  fixeRotationY(25);
}

void redefinirCertainsSommets(){
  /*
  if (pas < 360){
    prendrePhotos("img-"+pas+".png");
    pas+=10;
    fixeRotationY(pas);
  }
  */
  dv = (valG2*PI-c)/m;
  du = (valG1*2*PI - a)/n;
  // Calcul des sommets
  for(int i = 0; i <= n; i++){
    for(int j = 0; j <= m; j++){
      redefinirSommet(i*(m+1)+j+1, f(a+i*du, c+j*dv), g(a+i*du, c+j*dv), h(a+i*du, c+j*dv));
      //println(i*(m+1)+j+1);
    }//j
  }//i
}


